Ruby - Bug #10967

Is "warning: private attribute?" wrong?
03/11/2015 08:06 PM - spastorino (Santiago Pastorino)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 2.3.0dev (2015-03-01 trunk 49796) |Backport: 2.0.0: WONTFIX, 2.1: WONTFIX, 2.2:
[x86_64-darwin14] WONTFIX

Description
The following code ...

class Y
def initialize
@x = "ZOMG"
end

def print_x
puts x
end

private

attr_reader :x
end

Y.new.print_x
outputs ...
test.rb:12: warning: private attribute?

| tend to think this warning is wrong, | was surprised by https://github.com/rack/rack/pull/811 and | think this is a completely valid use
case.

Also this code ...

class Y
def initialize
@x = "ZOMG"
end

def print_x
puts x
end

def assign_x
self.x = "ZOMG ZOMG"
end

private

attr_accessor :x
end

y = Y.new
y.assign_x

y.print_x

Works fine with warnings also. So a private writer works ok when the receiver is self because Ruby has a special case for it, this
make me think that private writers were thought to be used.
So ... am | wrong thinking that the warning should be removed or the self special case shouldn't work and be removed from Ruby
code?. It doesn't make sense to me to have both things.

Associated revisions

Revision 32a5a098e39e377350e4696d2d9f2d8930f1ec41 - 05/21/2015 06:40 AM - zzak (zzak _)

¢ vm_method.c: Remove private attribute warning [Bug #10967]
Patch by @spastorino [Fixes GH-849]
https://github.com/ruby/ruby/pull/849

o test/ruby/test_module.rb: Update test for changes

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@50585 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 32a5a098 - 05/21/2015 06:40 AM - zzak (zzak _)

e vm_method.c: Remove private attribute warning [Bug #10967]
Patch by @spastorino [Fixes GH-849]
https://github.com/ruby/ruby/pull/849

e test/ruby/test_module.rb: Update test for changes

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@50585 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 03/12/2015 03:03 PM - spastorino (Santiago Pastorino)

One possible fix (the one removing the warning) ... https://github.com/ruby/ruby/pull/849

#2 - 04/27/2015 10:41 PM - nobu (Nobuyoshi Nakada)
- Description updated

It's valid in your case, but may not in others.
It doesn't sound enough reason to remove that warning to me.

If you want to suppress the warning, you can explicitly do it after the definition.

class Y
attr_writer :x
private :x=

end

#3 - 04/28/2015 12:25 AM - marcandre (Marc-Andre Lafortune)

FWIW, | feel that warning should be removed. There are too many false positives, and | suspect very very few cases where that warning is of any
help. Note that without the warning, it will be obvious anyways when calling that reader/writer that it fails because it is private.

#4 - 04/30/2015 06:23 PM - spastorino (Santiago Pastorino)

There's also a discussion going on in another PR, https://github.com/ruby/ruby/pull/889

@nobu (Nobuyoshi Nakada), not sure what are the invalid use cases you refer to, and also what if | need to use let's say 2 private accessors? should
ldo ...

attr_accessor :a, :b
private :a, :a=, :b, :b=

Doesn't sound great to me.

#5 - 05/14/2015 07:00 AM - matz (Yukihiro Matsumoto)

We haven't thought of self as a receiver. Agreed to remove warnings.
Matz.

#6 - 05/21/2015 06:41 AM - zzak (zzak _)
- Status changed from Open to Closed

Applied in changeset r50585.

e vm_method.c: Remove private attribute warning [Bug #10967]
Patch by @spastorino [Fixes GH-849]
https://github.com/ruby/ruby/pull/849

e test/ruby/test_module.rb: Update test for changes

#7 - 06/30/2015 04:18 AM - usa (Usaku NAKAMURA)
- Backport changed from 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2: UNKNOWN to 2.0.0: WONTFIX, 2.1: REQUIRED, 2.2: REQUIRED

#8 - 07/03/2015 08:33 AM - usa (Usaku NAKAMURA)

Is this a spec change or a bug?

#9 - 08/14/2015 06:45 AM - nagachika (Tomoyuki Chikanaga)
- Backport changed from 2.0.0: WONTFIX, 2.1: REQUIRED, 2.2: REQUIRED to 2.0.0: WONTFIX, 2.1: REQUIRED, 2.2: WONTFIX

Hmm, | don't know it's a bug fix or a spec change, but | think it's a trivial issue. | decided to not to backport to 2.2. Please notice if any objections.

#10 - 08/17/2015 08:53 AM - usa (Usaku NAKAMURA)
- Backport changed from 2.0.0: WONTFIX, 2.1: REQUIRED, 2.2: WONTFIX to 2.0.0: WONTFIX, 2.1: WONTFIX, 2.2: WONTFIX

Ok, | follow you, chikanaga-san!
